#!/bin/sh
#
# This nasty script generates git log output suitable for per-day commit 
# summaries. It ex

if [ "$1" = "" ]; then
    echo "Usage: git-per-day-summaries.sh <git-revision-range>"
    echo
    echo "Example:"
    echo "    git-per-day-summaries.sh 462b6d5...0eb3985"
    exit 1
fi


SHORTLASTDATE=""

git log --oneline --format="%h|%cD|%an|%s" $1|while read COMMIT; do

    COMMITID=`echo $COMMIT|cut -d "|" -f 1`
    DATE=`echo $COMMIT|cut -d "|" -f 2`
    SHORTDATE=`echo $DATE|cut -d " " -f 2-4`
    WEEKDAY=`echo $DATE|cut -d " " -f 1|cut -d "," -f 1`
    AUTHORNAME=`echo $COMMIT|cut -d "|" -f 3`
    SUBJECT=`echo $COMMIT|cut -d "|" -f 4`

    if [ "$SHORTDATE" = "$SHORTLASTDATE" ]; then
        echo "  * $AUTHORNAME: $SUBJECT ($COMMITID)"
    else
        echo " * $SHORTDATE ($WEEKDAY):"
        echo "  * $AUTHORNAME: $SUBJECT ($COMMITID)"
    fi

    SHORTLASTDATE=$SHORTDATE

done
